package Robot;
import robocode.*;
import java.awt.Color;

/**
 * Biciadu - a robot by (your name here)
 */
public class Biciadu extends AdvancedRobot
{
	double targetBearing;
	boolean naofalhou = true;
	int radar = 360;
	/**
	 * run: Biciadu's default behavior
	 */
	

	
	public void run() {
		// After trying out your robot, try uncommenting the import at the top,
		// and the next line:
		setColors(Color.black,Color.white,Color.black);
		
		while(true) {
		
			// Replace the next 4 lines with any behavior you would like
			setAhead(50*Math.tan(getTime()/10));
			setTurnRight(10*Math.cos(getTime()/10));
			setTurnRadarRight(radar);
			execute();
		}
	}

	public void rodaArma(ScannedRobotEvent e){
		double absBearing = e.getBearingRadians() + getHeadingRadians();
		double eX = e.getDistance()*Math.sin(absBearing);	
		double eY = e.getDistance()*Math.cos(absBearing);	
		
		setTurnGunRightRadians(Math.asin(Math.sin(Math.atan2(eX,eY)-getGunHeadingRadians())));
		setTurnRadarRight(360);		
		execute();
	}

	public void dispara(){
		naofalhou = true;
		while(naofalhou){
			fire(2);	
			setAhead(20*Math.cos(getTime()/10));
			execute();
			
		}			
	}

	public void onBulletMissed(BulletMissedEvent e){
		naofalhou = false;	
	}
	/**
	 * onScannedRobot: What to do when you see another robot
	 */
	public void onScannedRobot(ScannedRobotEvent e) {
		double targetBearing = e.getBearing();
		radar = 360;
		if (e.getEnergy() != 0){
			while(e.getEnergy()!=0){
			rodaArma(e);
			dispara();}
			afasta(e);
		}
		else
			ramIt(e);
		double enemyB= e.getBearing();
		if((enemyB > -45 && enemyB < 45) || (enemyB < -135 && enemyB > 135))
 			setTurnRight(90);
	}


	public void afasta(ScannedRobotEvent e){
		if(e.getDistance() < 100){
			turnLeft(getHeading());
			back(300);
			turnRight(90);
			setAhead(20*Math.cos(getTime()/10));
			setTurnRadarRight(360);
			execute();
		}		
	}
	
	public void ramIt(ScannedRobotEvent e){
		turnRight(e.getBearing());
		ahead(10000);		
	}

	
}
